/*Copyright (C) 2010-2012 Duncan Deveaux

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEF_BUTTON
#define DEF_BUTTON

#include "Graphics/Drawable/Polygon.hpp"
#include "Structs/Box.hpp"

//Drawable inheriting class representing an empty Button
class Button : public Drawable
{
    public:
        Button();
        Button(float width, float height, const Color &color);
        void draw();
        
        bool mouseHitTest(const Vector &mousePosition);
        
        void enableBackground(bool background);
        bool backgroundEnabled() const;
        
        void enableBorder(bool border);
        bool borderEnabled() const;
        
        void setBackgroundColor(const Color &backgroundColor);
        const Color &getBackgroundColor() const;
        
        void setBorderColor(const Color &borderColor);
        const Color &getBorderColor() const;
        
        void setBorderSize(float borderSize);
        float getBorderSize() const;
        
        float getWidth() const;
        float getHeight() const;
        
    protected:
        Polygon m_background;
        
        float m_width;
        float m_height;
};

#endif
